module GenericSnapshot where

{-# LANGUAGE MultiParamTypeClasses,
FlexibleInstances,
FlexibleContexts,
TypeFamilies,
ScopedTypeVariables,
DefaultSignatures,
RankNTypes,
DeriveAnyClass,
DeriveGeneric,
TypeOperators
#-}


-- This isn't working and I'm not sure why.

class GSnapshot m t where
  type GMemento t :: *
  type instance GMemento t = t
  
  gsnapshot :: Monad m => t -> m (GMemento t)
  default gsnapshot :: Monad m => t -> m t
  gsnapshot = return

instance Monad m => GSnapshot m (V1 p)
instance Monad m => GSnapshot m (U1 p)

instance
  (Monad m,
   GSnapshot m t1,
   GSnapshot m t2) => 
  GSnapshot m (t1 :*: t2) where

  type GMemento (t1 :*: t2) = GMemento t1 :*: GMemento t2
  
  gsnapshot (x1 :*: x2) = do
    y1 <- gsnapshot x1
    y2 <- gsnapshot x2
    return (y1 :*: y2)

 
instance
  (Monad m,
   GSnapshot m t1,
   GSnapshot m t2) => 
  GSnapshot m (t1 :+: t2) where

  type GMemento (t1 :+: t2) = (GMemento t1) :+: (GMemento t2)
  
  gsnapshot (L1 x) = do
    y <- gsnapshot x
    return (L1 y)

  gsnapshot (R1 x) = do
    y <- gsnapshot x
    return (R1 x)


instance
  (Monad m,
   Snapshot m c) =>
  GSnapshot m (K1 i c) where

  type GMemento (K1 i c) = K1 i (GMemento c)

  gsnapshot (K1 x) = do
    y <- snapshot x
    return (K1 y)


instance
  (Monad m) =>
  GSnapshot m (M1 i t f) where

  type GMemento (M1 i t f) = M1 i t (GMemento f)

  gsnapshot (M1 x) = do
    y <- gsnapshot x
    return (M1 y)
